/* 
erstellt von Thomas Reincke, https://blog.5zu6.de

Nutzungsrechte und Haftungsausschluß

Die Dateien veröffentliche ich unter CC BY-SA 3.0 DE (Namensnennung – Weitergabe unter gleichen Bedingungen 3.0 Deutschland).

Darüber hinaus würde ich mich freuen, wenn bei der Verwendung in Modellen auf meine Urheberschaft hingewiesen würde. Ebenso würde ich mich über Kommentare mit Erfahrungsberichten oder Fotos über der Verwendung und Verfeinerung freuen.

Ich gebe keine Garantien hinsichtlich des Werks und übernimmt keinerlei Haftung für irgendwelche Nutzungen des Werks, soweit das gesetzlich möglich ist.

Vor der Fertigung oder Bestellung größerer Mengen empfehle ich den Probedruck eines einzelnen Exemplar und dessen sorgfältige Kontrolle.

Weitere Hinweise unter 
https://blog.5zu6.de/das-rad-neu-erfunden-1/
https://blog.5zu6.de/das-rad-neu-erfunden-2/
https://blog.5zu6.de/das-rad-neu-erfunden-3/
https://blog.5zu6.de/das-rad-neu-erfunden-4/
*/

/* ********** */

//bei zweifarbigem Ausdruck getrennte Objekte für Radreifen und Radscheibe
Radreifen       = 1;
Radscheibe      = 1;
// für Räder mit und ohne Spurkranz
Spurkranz       = 1;

//Beschreibungstext auf der Innenseite
Txt             = 0;


// Default-Werte; Änderungen wirken sich auf alle Räder aus!
RadDurchmesser  = 24.00;
SpurkranzHoehe  =  3.00; 
RadBreite       =  0.93;
GesBreite       =  1.00;
SpeichenAnzahl  =  0;
SpeichenWinkel  =  0.00;
Nabenwinkel     =  0.00;
Kurbelzapfen    =  0;
Kurbelkreuz     =  0;
NabeD           =  1.00;
Gegengewicht    =  0;
GgwRadius       =  0.00;
GgwIDurchm      =  8*NabeD+0.2;
GgwVersatz      =  0.00;
GgwWinkel       =  0.00;
RiA2            =  1.00;
Haftreifen      =  1.10;
Achsstand       =  5.00;
Huelse          =  0.50;//0.25; //Objekt zum Druck ca. 2mm in z-Richtung verschieben und mit Stützmaterial drucken

Mindestradius   = 40.00;
Spurweite       =  4.00;
GleisInnen      =  2.80; // Rillenbreite
Bremsscheibe    =  0;
// Ende Default-Werte

/*
Beschreibung    = "kleines Rad"; //d=525mm
RadDurchmesser  = 12.5;
RadBreite       = 2/3;
Haftreifen      = 0;
Achsstand       = 4.00;
*/

/*
Beschreibung    = "BR 01 Laufrad vorne";// d=1000 mm
RadDurchmesser  = 24;
SpeichenAnzahl  = 13;
Haftreifen      = 0;
Achsstand       = 7;
*/

/*
Beschreibung    = "BR 01 Laufrad hinten";// d=1250 mm
RadDurchmesser  = 30.4;
SpeichenAnzahl  = 11;
Haftreifen      = 0;
Achsstand       = 0;
*/

/*
Beschreibung    = "BR 01  Treibrad Achse 1+3"; 
RadDurchmesser  = 48;
SpeichenAnzahl  = 21;
Nabenwinkel     = 0;
Kurbelzapfen    = 1;
NabeD           = 1.5;
Gegengewicht    = 1;
GgwVersatz      = 0.344;
GgwRadius       = 2.5;
GgwWinkel       = -5;
Achsstand       = 14;
Mindestradius   = 56;
*/

/*
Beschreibung    = "BR 01  Treibrad Achse 2"; 
RadDurchmesser  = 48;
SpeichenAnzahl  = 21;
Nabenwinkel     = 0;
Kurbelzapfen    = 1;
NabeD           = 1.5;
Gegengewicht    = 1;
GgwVersatz      = 0.379;
GgwRadius       = 2.5;
GgwWinkel       = -5.25;
*/

/*
Beschreibung    = "BR 01.10 Treibrad vorne rechts"; 
RadDurchmesser  = 48;
SpeichenAnzahl  = 21;
Nabenwinkel     = 0;
Kurbelzapfen    = 1;
NabeD           = 1.5;
Gegengewicht    = 1;
GgwVersatz      = 0.344;
GgwRadius       = 2.5;
GgwWinkel       = -56.94;
Achsstand       = 14;
Mindestradius   = 56;
*/

/*
Beschreibung    = "BR 01.10 Treibrad vorne links"; 
RadDurchmesser  = 48;
SpeichenAnzahl  = 21;
Nabenwinkel     = 30;
Kurbelzapfen    = 1;
NabeD           = 1.5;
Gegengewicht    = 1;
GgwVersatz      = 0.339;
GgwRadius       = 2.5;
GgwWinkel       = -62.58;
Achsstand       = 14;
Mindestradius   = 56;
*/

/*
Beschreibung    = "BR 01.10 Treibrad mitte rechts"; 
RadDurchmesser  = 48;
SpeichenAnzahl  = 21;
Nabenwinkel     = 0;
Kurbelzapfen    = 1;
NabeD           = 1.5;
Gegengewicht    = 1;
GgwVersatz      = .379; 
GgwRadius       = 2.5;
GgwWinkel       = -4.46;
Achsstand       = 14;
*/

/*
Beschreibung    = "BR 01.10 Treibrad mitte links"; 
RadDurchmesser  = 48;
SpeichenAnzahl  = 21;
Nabenwinkel     = 30;
Kurbelzapfen    = 1;
NabeD           = 1.5;
Gegengewicht    = 1;
GgwVersatz      = .358; 
GgwRadius       = 2.5;
GgwWinkel       = -3.98;
Achsstand       = 14;
*/
 
/* 
Beschreibung    = "BR 01.10 Koppelrad hinten rechts";
RadDurchmesser  = 48;
SpeichenAnzahl  = 21;
Nabenwinkel     = 0;
Kurbelzapfen    = 1;
NabeD           = 1.5;
Gegengewicht    = 1;
GgwVersatz      = 0.344;
GgwRadius       = 2.5;
GgwWinkel       = -2;
Achsstand       = 14;
*/

/* 
Beschreibung    = "BR 01.10 Koppelrad hinten links";
RadDurchmesser  = 48;
SpeichenAnzahl  = 21;
Nabenwinkel     = 30;
Kurbelzapfen    = 1;
NabeD           = 1.5;
Gegengewicht    = 1;
GgwVersatz      = 0.338;
GgwRadius       = 2.5;
GgwWinkel       = -2.5;
Achsstand       = 14;
*/

/*
Beschreibung    = "BR 44 Treibrad Achse 1+5";
RadDurchmesser  = 33.6; 
SpeichenAnzahl  = 15;
SpeichenWinkel  = 180;
Kurbelzapfen    = 1;
NabeD           = 1.35;
Nabenwinkel     = 0;
Gegengewicht    = 1;
GgwVersatz      = 0.25;
GgwRadius       = 1000/700;
GgwWinkel       = -7;
Achsstand       = 10;
*/

/*
Beschreibung    = "BR 44/50 Laufrad"; //d=850 mm
RadDurchmesser  = 20.8;//20.24;
SpeichenAnzahl  = 9;
Spurkranz       = 1;
Haftreifen      = 0;
Achsstand       = 0;
*/

/*
Beschreibung    = "BR 50 Treibrad Achse 1+5";
RadDurchmesser  = 33.6; 
SpeichenAnzahl  = 15;
SpeichenWinkel  = 180;
Kurbelzapfen    = 1;
NabeD           = 1.35;
Gegengewicht    = 1;
GgwVersatz      = 0.25;
GgwRadius       = 1000/700;
GgwWinkel       = -7;
Achsstand       = 10;
*/

/*
Beschreibung    = "BR 50 Treibrad Achse 3";
RadDurchmesser  = 33.6;
SpeichenAnzahl  = 15;
SpeichenWinkel  = 180;
Kurbelzapfen    = 1;
NabeD           = 1.35;
Gegengewicht    = 1;
GgwVersatz      = 530/1400;
GgwRadius       = 1000/700;
GgwWinkel       = -7.43;
Achsstand       = 10;
*/

/*
Beschreibung    = "BR 50 Treibrad Achse 2+4";
RadDurchmesser  = 33.6; 
SpeichenAnzahl  = 15;
SpeichenWinkel  = 180;
Kurbelzapfen    = 1;
NabeD           = 1.35;
Gegengewicht    = 1;
GgwVersatz      = 0.265;
GgwRadius       = 1000/700;
GgwWinkel       = -7;
Achsstand       = 10;
*/

/*
Beschreibung    = "pr. G8.1 Achse 1+4"; //BR 55
RadDurchmesser  = 32;
SpeichenAnzahl  = 16;
Kurbelzapfen    = 1;
Kurbelkreuz     = 1;
NabeD           = 1.25;
Gegengewicht    = 1;
GgwVersatz      = 0.296;//0.25;
GgwRadius       = 0;
GgwWinkel       = -5.14;
Achsstand       = 15;
*/

/*
Beschreibung    = "pr. G8.1 Achse 2"; //d=1350 mm
RadDurchmesser  = 32;
RadBreite       =  0.43;
GesBreite       =  0.50;
SpeichenAnzahl  = 16;
Kurbelzapfen    = 1;
NabeD           = 1.25;
Gegengewicht    = 1;
GgwVersatz      = 0.274;//0.25;
GgwRadius       = 0;
GgwWinkel       = -4.95;
Achsstand       = 5;
*/

/*
Beschreibung    = "pr. G8.1 Achse 3"; //d=1350 mm
RadDurchmesser  = 32;//32.14;
SpeichenAnzahl  = 16;
Kurbelzapfen    = 1;
NabeD           = 1.25;
Gegengewicht    = 1;
GgwVersatz      = 0.037;//0.25;
GgwRadius       = 0;
//GgwIDurchm      =  8*NabeD+1;
GgwWinkel       = -4.95;
Achsstand       = 5;
*/

/*
// DRG BR 75.0 - Württembergische T5
Beschreibung    = "Württ. T5 Laufrad"; //d=943 mm
RadDurchmesser  = 22.5;
SpeichenAnzahl  = 9;
Haftreifen      = 0;
RiA2            = 0;
Achsstand       = 0;
*/

/*
Beschreibung    = "Württ. T5  Achse 1+3"; //d=1450 mm
RadDurchmesser  = 34.5;
SpeichenAnzahl  = 16;
Kurbelzapfen    = 1;
NabeD           = 1.19;
Gegengewicht    = 1;
GgwVersatz      = 0.335;
GgwRadius       = 2;
GgwWinkel       = -3;
RiA2            = 0;
Achsstand       = 11;
*/

/*
Beschreibung    = "Württ. T5  Achse 2"; //d=1450 mm
RadDurchmesser  = 34.5;
RadBreite       =  0.63;
GesBreite       =  0.70;
SpeichenAnzahl  = 16;
Kurbelzapfen    = 1;
Kurbelkreuz     = 0;
NabeD           = 1.19;
Gegengewicht    = 1;
GgwVersatz      = 0.382;//0.25;
GgwRadius       = 2.00;
GgwWinkel       = -7;
RiA2            = 0;
Haftreifen      = 0;
Achsstand       = 12;
//Huelse          = 0; //da seitenverschieblich
*/

/*
Beschreibung    = "pr. T16.1 - Achse 1+2+4+5"; //d=1350 mm
RadDurchmesser  = 32.1;
SpeichenAnzahl  = 14;
SpeichenWinkel  = 360/14/2;
Kurbelzapfen    = 1;
NabeD           = 1.16;
Gegengewicht    = 1;
GgwVersatz      = 0.29;
GgwRadius       = 0;
GgwWinkel       = -5;
Achsstand       = 9;
*/

/*
Beschreibung    = "pr. T16.1 - Achse 3"; //d=1350 mm
RadDurchmesser  = 32.1;
SpeichenAnzahl  = 14;
SpeichenWinkel  = 360/14/2;
Kurbelzapfen    = 1;
NabeD           = 1.16;
Gegengewicht    = 1;
GgwVersatz      = 0.16;
GgwRadius       = 0;
GgwIDurchm      = 15.8; 
GgwWinkel       = -6.21;
Achsstand       = 9;
*/

/*
Beschreibung    = "Bay. S3/6 Laufrad vorne";// d=950 mm
RadDurchmesser  = 22.6;
SpeichenAnzahl  = 9;
Haftreifen      = 0;
Achsstand       = 7; //6.5
//Mindestradius   = 104;
*/

/*
Beschreibung    = "Bay. S3/6 Treibrad Achse 2 rechts"; 
RadDurchmesser  = 44.5;
SpeichenAnzahl  = 18;
SpeichenWinkel  = 10;
Kurbelzapfen    = 1;
Kurbelkreuz     = 1;
NabeD           = 1;
Gegengewicht    = 1;
GgwVersatz      = 0.37;
GgwRadius       = 5000/1870;
GgwWinkel       = -45-10;
Achsstand       = 14;
Mindestradius   = 55;
*/

/*
Beschreibung    = "Bay. S3/6 Treibrad Achse 2 links"; 
RadDurchmesser  = 44.5;
SpeichenAnzahl  = 18;
SpeichenWinkel  = 10;
Kurbelzapfen    = 1;
Kurbelkreuz     = 1;
NabeD           = 1;
Gegengewicht    = 1;
GgwVersatz      = 0.360;
GgwRadius       = 5000/1870;
GgwWinkel       = -45-6.89;
Achsstand       = 14;
Mindestradius   = 55;
*/

/*
Beschreibung    = "Bay. S3/6 Treibrad Achse 1+3"; 
RadDurchmesser  = 44.5;
SpeichenAnzahl  = 18;
SpeichenWinkel  = 10;
Kurbelzapfen    = 1;
NabeD           = 1;
Gegengewicht    = 1;
GgwVersatz      = 0.351;
GgwRadius       = 5000/1870;
GgwWinkel       = -5;
Achsstand       = 14;
Mindestradius   = 104;
*/

/*
Beschreibung    = "Bay. S3/6 Laufrad hinten";// d=1265 mm
RadDurchmesser  = 30.1;
SpeichenAnzahl  = 12;
Haftreifen      = 0;
Achsstand       = 0;
*/

/*
Beschreibung    = "Jung R42C Achse 1"; //d=1100mm
RadDurchmesser  = 26.2;
SpeichenAnzahl  = 11;
Kurbelzapfen    = 1;
Gegengewicht    = 1;
GgwVersatz      = 0.36;
GgwRadius       = 2;
GgwWinkel       = -5;
RiA2            = 1.50;
Achsstand       = 10;
*/

/*
Beschreibung    = "Jung R42C Achse 2";
RadDurchmesser  = 26.2;
RadBreite       =  0.68;
GesBreite       =  0.75;
SpeichenAnzahl  = 11;
Kurbelzapfen    = 1;
Kurbelkreuz     = 1;
Gegengewicht    = 1;
GgwVersatz      = 0.4;
GgwRadius       = 2;
GgwWinkel       = -4;
RiA2            = 1.50;
Haftreifen      = 1;
Achsstand       = 0;
Huelse          = 0; //da seitenverschieblich
*/

/*
Beschreibung    = "Jung R42C Achse 3";
RadDurchmesser  = 26.2;
SpeichenAnzahl  = 11;
Kurbelzapfen    = 1;
Gegengewicht    = 1;
GgwVersatz      = 0.4;
GgwRadius       = 2;
GgwWinkel       = -4;
RiA2            = 1.50;
Achsstand       = 10;
*/

/*
Beschreibung    = "V60 DB - Achse 1"; //d=1250 mm
RadDurchmesser  = 32.0;//32.14;
SpeichenAnzahl  = 13;
SpeichenWinkel  = 180;
Kurbelzapfen    = 1;
NabeD           = 1.30;
Gegengewicht    = 1;
GgwVersatz      = 0.39;
GgwRadius       = 2.5;
GgwWinkel       = -5;
RiA2            = 99; //max
Achsstand       = 13;
*/

/*
Beschreibung    = "V60 DB - Achse 2"; //d=1250 mm
RadDurchmesser  = 32.0;//32.14;
SpeichenAnzahl  = 13;
SpeichenWinkel  = 180;
Kurbelzapfen    = 1;
NabeD           = 1.30;
Gegengewicht    = 1;
GgwVersatz      = 0.405;
GgwRadius       = 2.5;
GgwWinkel       = -4;
RiA2            = 99; //max
Achsstand       = 0;
*/

/*
Beschreibung    = "V60 - DB Achse 3"; //d=1250 mm
RadDurchmesser  = 32.0;//32.14;
SpeichenAnzahl  = 13;
SpeichenWinkel  = 180;
Kurbelzapfen    = 1;
NabeD           = 1.30;
Gegengewicht    = 1;
GgwVersatz      = 0.375;
GgwRadius       = 2.5;
GgwWinkel       = -5;
RiA2            = 99; //max
Achsstand       = 13;
*/

/*
Beschreibung    = "V65 DB Treibrad außen"; //d=1250mm
// RadD und SpK wg. Achsstand reduziert
RadDurchmesser  = 28.3;//29.8;
SpurkranzHoehe  = 1.8;//3.00;
SpeichenAnzahl  = 12;
Kurbelzapfen    = 1;
Kurbelkreuz     = 1;
NabeD           = 1.25;
Gegengewicht    = 1;
GgwVersatz      = 0.35;
GgwRadius       = 1.35;
GgwWinkel       = -5;
Achsstand       = 17;
*/

/*
Beschreibung    = "V65 DB Treibrad innen"; //d=1250mm
RadDurchmesser  = 28.3;//29.8;
SpurkranzHoehe  = 1.8;//3.00;
SpeichenAnzahl  = 12;
Kurbelzapfen    = 1;
Kurbelkreuz     = 0;
NabeD           = 1.25;
Gegengewicht    = 1;
GgwVersatz      = 0.35;
GgwRadius       = 1.35;
GgwWinkel       = -5;
Achsstand       = 9;
*/

/*
Beschreibung    = "E52 Laufrad"; //d=850 mm
RadDurchmesser  = 20.8;//20.24;
SpeichenAnzahl  = 8;
Haftreifen      = 0;
Achsstand       = 5.5;
*/

/*
Beschreibung    = "E52 DB Treibrad innen";// d=1400mm
RadDurchmesser  = 33.6;
SpeichenAnzahl  = 12;
SpeichenWinkel  = 360/14/2;
Kurbelzapfen    = 1;
Kurbelkreuz     = 0;
NabeD           = 1.15;
Gegengewicht    = 1;
GgwVersatz      = 0.374;
GgwRadius       = 2.5;
GgwWinkel       = -6.5;
Achsstand       = 8;
*/

/*
Beschreibung    = "E94 Treibrad"; //d=1250mm
RadDurchmesser  = 28.3;
SpeichenAnzahl  = 13;
NabeD           = 1.15;
Achsstand       = 13;
*/

/*
Beschreibung    = "Scheibenrad Traxx"; //d=1250mm
RadDurchmesser  = 29.8; //28.3;
SpeichenAnzahl  = 0;
NabeD           = 1.15;
Achsstand       = 8;
RadBreite       =  0.55;
GesBreite       =  0.625;//1.00;//0.67;
Huelse          =  0.250;
Haftreifen      =  1;
Bremsscheibe    =  1;
*/

/*
Beschreibung    = "Scheibenrad Tender 2'2'T26"; //d=1000 mm
RadDurchmesser  = 24; 
Haftreifen      = 1;
Achsstand       = 6;
*/

/*
Beschreibung    = "Speichenrad Tender 2'2'T26"; //d=1000 mm
RadDurchmesser  = 24;
SpeichenAnzahl  = 11;
Haftreifen      = 0;
Achsstand       = 6;
*/

/*
Beschreibung    = "Speichenrad Tender 3T16,5"; //d=1000 mm
RadDurchmesser  = 24;
SpeichenAnzahl  = 11;
Haftreifen      = 0;
Achsstand       = 13;
*/


Beschreibung    = "Länderbahnrad";
RadDurchmesser  = 28;
RadBreite       = 0.83;//0.55;
GesBreite       = 1;//0.625;
SpeichenAnzahl  = 11;
Haftreifen      = 0;
RiA2            = 99; //max
Achsstand       = 8;


// Kalibrierung
SteinBreite   = 8.00;
SteinHoehe    = 9.60;
Luecke        = 0.10;
Luecken       = 2*Luecke;
Wandstaerke   = 1.40;

AchsBreite    = 1.88;//1.85;
AchsLaenge    = 4.90;//4.85;
AchsKrWinkel  = 1.25;
AchsInkreisD  = 0;//3.3;

NoppenDaussen = 4.95; //V1=4.80
NoppenDinnen  = 3.30; //V1=3.25
NoppenHoehe   = 1.80;

BodenHoehe    = 2.25;//SteinHoehe/4.5;
BodenSeitRohr = 1.30; //alter Wert 1,20

FaseD         = 6.20; // Durchmesser der Bohrung um Technik-Loch
FaseT         = 0.85; // Tiefe der Fase

pi = 3.1415926536;

fnDetail = RadDurchmesser*pi/2;//100;
fnGrob   = 18;

$fn = fnGrob;
//mindest-Spurkranzbreite wg. Stabilität und Fertigungstechnik
SpkBmin  = 1.05;

/*
klein:      8.2 mm
alt:       14.6 mm ohne Haftreifen
normal:    17.0 mm 55423
BBB S:     17.6 mm
BBB M:     24.0 mm
dampflok:  30.0 mm 85489a/b
BBB L:     30.4 mm
BBB XL:    36.8 mm
*/

RadreifenDurchmesser = RadDurchmesser;
NabeAussen  = SteinBreite*NabeD-Luecken;

RadAussenDurchmesser = RadDurchmesser+2*SpurkranzHoehe;
SpeichenBreite = Wandstaerke;

HRz = 2.5;//Wandstaerke/2*3+SpurkranzHoehe/4+Haftreifen/2+3*Luecke;

// Berechnung der maximalen Spurkranzbreite für Kurvengängigkeit
Alf = 2*sqrt(pow((RadDurchmesser/2+SpurkranzHoehe),2) - pow((RadDurchmesser/2),2)); //Auflagerlänge des Rades
Ra = (Mindestradius+Spurweite/2)*SteinBreite+GleisInnen; // Raduis Außenschiene Innen
Ri = (Mindestradius-Spurweite/2)*SteinBreite-GleisInnen; // Radius Innenschiene Außen
Ha = sqrt(pow(Ra,2)-pow(((Achsstand*SteinBreite+Alf)/2),2));
Hi = Ha-Spurweite*SteinBreite;
Rimax = sqrt(pow(Hi,2)+pow(((Achsstand*SteinBreite-Alf)/2),2)); 
// Spurkranzbreite wird ggf. auf Mindestmaß gesetzt. 
SpkB = max(min((Rimax-Ri)/2-Luecke,GleisInnen-Luecken),SpkBmin);


// fuer Beschriftung
chars = (Gegengewicht==0) ? str(" * ", Beschreibung," * As=",Achsstand) : str(" * ", Beschreibung," * GgwV=",GgwVersatz," * GgwR=",GgwRadius," * GgwW=",GgwWinkel," * As=",Achsstand); 
textradius = RadDurchmesser/2-2*Wandstaerke+Luecken;

module DiffSpeichen() {
  cylinder(d=RadDurchmesser-4*Wandstaerke, h=RadBreite*SteinBreite-Luecken-Huelse, $fn=fnDetail);
};  

module DrawSpeichen() {
  SpH = RadBreite*SteinBreite-Luecken-Huelse-Luecken-Wandstaerke/2; //SpeichenHoehe
  
  SpWi =  atan(((RadBreite*SteinBreite-Luecken-Huelse-SpH)/(RadDurchmesser-4*Wandstaerke))*2);

 
  for(i=[0:SpeichenAnzahl-1]) {
/*  // rechteckige Speichen
    rotate([0,0,i/SpeichenAnzahl*360+SpeichenWinkel])
    translate([0,-SpeichenBreite/2,SteinHoehe/2])
    cube([(RadDurchmesser-3.5*Wandstaerke)/2, SpeichenBreite, RadBreite*SteinBreite-Luecken-Huelse-Wandstaerke/2-SteinHoehe/2]); */   
/*  // ovale Speichen
    rotate([90,0,i/SpeichenAnzahl*360+180+SpeichenWinkel])
    translate([0,SpH/2,0])
    scale([1,SpH/SpeichenBreite,1])
    cylinder(d=SpeichenBreite, h=(RadDurchmesser-3.5*Wandstaerke)/2); */
    hull() {
      rotate([90,0,i/SpeichenAnzahl*360+180+SpeichenWinkel])
      translate([0,SpeichenBreite*.65/2,0])
      cylinder(d=SpeichenBreite*.65, h=(RadDurchmesser-3.5*Wandstaerke)/2);
  
      rotate([90,0,i/SpeichenAnzahl*360+180+SpeichenWinkel])
      translate([0,SpH/2,0])
      cylinder(d=SpeichenBreite, h=(RadDurchmesser-3.5*Wandstaerke)/2);
      
      rotate([90+SpWi,0,i/SpeichenAnzahl*360+180+SpeichenWinkel])
      translate([0,RadBreite*SteinBreite-Luecken-Huelse-SpeichenBreite*.85/2,0])
      cylinder(d=SpeichenBreite*.85, h=(RadDurchmesser-3.5*Wandstaerke)/2);    
    };
  };

  // Ausrundung innen
  Rb = (NabeD*SteinBreite-Luecken)/2*1.25;
  alpha2 = asin(SpeichenBreite/2/Rb);
  alpha1 = 180/SpeichenAnzahl-alpha2;
  RiA = sin(alpha1)*Rb; // Radius der inneren Speichenausrundung in mm  
  translate([0,0,(RadBreite*SteinBreite-Luecken-Huelse-Wandstaerke)/2])
  difference() {
    cylinder(r=Rb, h=Wandstaerke);
    for(i=[0:SpeichenAnzahl-1]) { 
      rotate([0,0,(i+0.5)/SpeichenAnzahl*360+SpeichenWinkel])
      translate([0,Rb,0])
    cylinder(r=RiA, h=RadBreite*SteinBreite);      
    };  
  }; 
 // Ausrundung außen  

  // maximaler Radius, z.B. V60) 
  RiA2 = min(RiA2, (pi*RadDurchmesser-SpeichenBreite)/4/SpeichenAnzahl);

  
  R2a = SpeichenBreite/2+RiA2;
  R2c = RadDurchmesser/2-2*Wandstaerke-RiA2;
  alpha3 = asin(R2a/R2c);
  for(i=[0:SpeichenAnzahl-1]) {    
    difference() {
      // Rechteck
      rotate([0,0,i/SpeichenAnzahl*360+90+SpeichenWinkel])
        translate([RadDurchmesser/2-2*Wandstaerke-RiA2,-SpeichenBreite/2-RiA2,(RadBreite*SteinBreite-Luecken-Huelse-Wandstaerke)/2])
      cube([RiA2,SpeichenBreite+2*RiA2,Wandstaerke]);
    
      rotate([0,0,i/SpeichenAnzahl*360+90+alpha3+SpeichenWinkel])
        translate([(RadDurchmesser-4*Wandstaerke)/2-RiA2,0,0])
        cylinder(r=RiA2, h=RadBreite*SteinBreite);

      rotate([0,0,i/SpeichenAnzahl*360+90-alpha3+SpeichenWinkel])
        translate([(RadDurchmesser-4*Wandstaerke)/2-RiA2,0,0])
        cylinder(r=RiA2, h=RadBreite*SteinBreite);

    };
  };
};

module DrawRadreifen() {
  difference() {
    union() {
      if (Spurkranz > 0) {       
        // Spurkranzscheibe
        cylinder(h=SpkB/2, d=RadAussenDurchmesser, $fn=fnDetail);
       
        // Spurkranz außen
        translate([0,0,SpkB/2])
        cylinder(h=min(RadBreite*SteinBreite-Huelse-Wandstaerke*1.5-SpkB/2, SpurkranzHoehe*.5, GleisInnen-SpkB/2)-Luecken, d1=RadAussenDurchmesser, d2=RadDurchmesser, $fn=fnDetail);
      }; 
      cylinder(h=RadBreite*SteinBreite-Luecken-Huelse, d1=RadDurchmesser, d2=RadDurchmesser-(RadBreite*SteinBreite-Luecken-Huelse)/40, $fn=fnDetail);
    };
    cylinder(h=RadBreite*SteinBreite-Luecken-Huelse, d=RadDurchmesser-2*Wandstaerke, $fn=fnDetail); 
  };  
};  
    
module DrawRadscheibe() {
 difference() {  
  cylinder(h=RadBreite*SteinBreite-Luecken-Huelse-Wandstaerke/2, d=RadDurchmesser-2*Wandstaerke, $fn=fnDetail);  
  
  cylinder(d=RadDurchmesser-4*Wandstaerke, h=(RadBreite*SteinBreite-Luecken-Huelse)/3, $fn=fnDetail);  
 }; 
};

module DiffAchshalter() {
    translate([0,0,0])
    cylinder(d=/*NabeAussen*/SteinBreite-Luecken, h=max(RadBreite*SteinBreite+5, SteinBreite+5, RadBreite*SteinBreite+5), center=false);   
  
    if (SpeichenAnzahl < 1) {
    translate([0,0,0])
    cylinder(d=NabeAussen+2*Wandstaerke, h=min(GesBreite*SteinBreite-Luecken-Huelse-SteinBreite/2, RadBreite*SteinBreite-Luecken-Huelse-SteinBreite/2),center=false);   
    };
};

module DrawNabe() {
  difference() {  
    // Achshalter bis ganzen Steinbreite
    cylinder(h=GesBreite*SteinBreite-Luecken-Huelse, d=NabeD*SteinBreite-Luecken); 
    cylinder(h=GesBreite*SteinBreite, d=SteinBreite-Luecken);
  };
};

module DrawAchshalter() {
  difference() {  
    // Achshalter bis ganzen Steinbreite
    cylinder(h=GesBreite*SteinBreite-Luecken-Huelse, d=/*NabeD**/SteinBreite-Luecken, center=false); 
    cylinder(h=GesBreite*SteinBreite, d=AchsLaenge, center=false);

    // Fase am Achseinlauf unten
      cylinder(h=Luecken*2, d2=AchsLaenge, d1=AchsLaenge+4*Luecken, center=false);

    // Fase am Achseinlauf oben
    translate([0,0,GesBreite*SteinBreite-Luecken-Huelse-2*Luecken])
      cylinder(h=Luecken*2, d1=AchsLaenge, d2=AchsLaenge+4*Luecken, center=false);
 };
  // Achsenkreuz
  difference() {
    translate([0,0,2*Luecken])
    cylinder(h=GesBreite*SteinBreite-Luecken-Huelse-4*Luecken, d=AchsLaenge, center=false);       
    rotate([0,0,AchsKrWinkel])             
    translate([-AchsBreite/2, -AchsLaenge/2-Luecke, -1])
      cube([AchsBreite, AchsLaenge+Luecken, SteinBreite+2]);
rotate([0,0,-AchsKrWinkel])             
    translate([-AchsBreite/2, -AchsLaenge/2-Luecke, -1])
      cube([AchsBreite, AchsLaenge+Luecken, SteinBreite+2]);
rotate([0,0,AchsKrWinkel]) 
    translate([-AchsLaenge/2-Luecke, -AchsBreite/2, -1])
      cube([AchsLaenge+Luecken, AchsBreite, SteinBreite+2]);
rotate([0,0,-AchsKrWinkel]) 
    translate([-AchsLaenge/2-Luecke, -AchsBreite/2, -1])
      cube([AchsLaenge+Luecke, AchsBreite, SteinBreite+2]);

    // Innkreis
    translate([0, 0, -1])
        cylinder(h=SteinBreite+2, d=AchsInkreisD, center=false);
  };
};

module DiffKurbelzapfen() {
  translate([0,-SteinBreite,0])
  cylinder(h=max(SteinBreite+5, GesBreite*SteinBreite+5), d=SteinBreite-Luecken);
};

module DrawKurbelkreuz() {
  translate([0,-SteinBreite,0]) DrawAchshalter();
};

module DrawKurbelzapfen() {
  difference() {
    translate([0,-SteinBreite,0])
    cylinder(d=SteinBreite-Luecken, h=GesBreite*SteinBreite-Luecken-Huelse);
    translate([0,-SteinBreite,0])
    cylinder(d=AchsLaenge, h=GesBreite*SteinBreite-Luecken);
    translate([0,-SteinBreite,0])
    cylinder(d=FaseD, h=FaseT);

    translate([0,-SteinBreite,GesBreite*SteinBreite-Luecken-FaseT])
    cylinder(d=FaseD, h=FaseT);    
    
    if (Kurbelkreuz  > 0) { 
      translate([-AchsBreite/2, -SteinBreite, -1])
      cube([AchsBreite, SteinBreite/2, (GesBreite*SteinBreite-Luecken)/2+1]); 
    };    
  };  

  difference() {
  hull() {
    cylinder(h=GesBreite*SteinBreite-Luecken-Huelse, d=NabeAussen); 

    translate([0,-SteinBreite,0])
    cylinder(d=SteinBreite-Luecken, h=GesBreite*SteinBreite-Luecken-Huelse);
    };
    cylinder(h=GesBreite*SteinBreite-Luecken-Huelse, d=NabeAussen); 
    translate([0,-SteinBreite,0])
    cylinder(d=SteinBreite-Luecken, h=GesBreite*SteinBreite-Luecken-Huelse);

    R1 = (SteinBreite-Luecken)/2;
    R2 = (NabeD*SteinBreite-Luecken)/2;   
    la = R1+(R1+R2)/2;
    lb = R2+(R1+R2)/2;
    lc = SteinBreite;
    xc = (pow(lb,2)+pow(lc,2)-pow(la,2))/(2*lc);
    yc = sqrt(pow(lb,2)-pow(xc,2));
    translate([yc,-xc,0])
    cylinder(r=(R1+R2)/2, h=GesBreite*SteinBreite-Luecken-Huelse);    

    translate([-yc,-xc,0])
    cylinder(r=(R1+R2)/2, h=GesBreite*SteinBreite-Luecken-Huelse);
  };
};

module revolve_text(textradius, chars) {
// thanks to https://openhome.cc/eGossip/OpenSCAD/TextCircle.html
  chars_len = max(len(chars), (pi*RadDurchmesser)/(2*(Wandstaerke-Luecken)));
  font_size = min((pi*RadDurchmesser)/chars_len, 2*(Wandstaerke-Luecken));
  font_type = "Segoe UI Black";
  font_height = 1;
  step_angle = 360 / chars_len;
  mirror([1,0,0]) { 
    for(i = [0 : chars_len - 1]) {
      rotate(-i * step_angle) 
        translate([0, textradius, 0]) 
          linear_extrude(font_height) { text(chars[i], font=font_type, size = font_size, halign = "center", valign = "baseline"); };
    };
  };
};

module DrawGegengewicht() {
  if (GgwRadius > 0) {
    difference() {
      cylinder(h=GesBreite*SteinBreite-Luecken-Huelse-Luecken, d=RadDurchmesser-4*Wandstaerke, $fn=fnDetail);
      rotate([0,0,GgwWinkel])
      translate([0,-GgwVersatz*RadDurchmesser*GgwRadius,0])
      cylinder(h=GesBreite*SteinBreite, d=RadDurchmesser*GgwRadius, $fn=fnDetail);
      translate([0,0,0])
      cylinder(h=GesBreite*SteinBreite, d=GgwIDurchm, $fn=fnDetail);
    };
  };
  
  if (GgwRadius <= 0) {
    difference() {
      cylinder(h=GesBreite*SteinBreite-Luecken-Huelse-Luecken, d=RadDurchmesser-4*Wandstaerke, $fn=fnDetail);

      rotate([0,0,180+GgwWinkel])
      translate([-RadDurchmesser/2,-GgwVersatz*RadDurchmesser,0])
      cube([RadDurchmesser, RadDurchmesser, GesBreite*SteinBreite]);

      cylinder(h=GesBreite*SteinBreite, d=GgwIDurchm, $fn=fnDetail);      
    };
  }; 
};

module DiffHaftreifen() {
  $fn=fnDetail;
  rotate_extrude()
{ translate([RadDurchmesser/2-Haftreifen/2,
 HRz,0]) 
  circle(Haftreifen/2);    };
 

  difference() {
    
    translate([0,0,HRz-Haftreifen/2])
    cylinder(h=Haftreifen, d=RadDurchmesser);  

    translate([0,0,HRz-Haftreifen/2])
    cylinder(h=Haftreifen, d=RadDurchmesser-Haftreifen);  
  };

};

module DrawHuelse() {
  difference() {
    hull() {
      translate([0,0,-Huelse]) cylinder(h=Huelse, d=SteinBreite-Luecken);
      if (Kurbelzapfen == 1) { translate([0, -SteinBreite, -Huelse]) cylinder(h=Huelse, d=SteinBreite-Luecken); };   
    };
    translate([0,0,-Huelse]) cylinder(h=Huelse, d=FaseD);
    if (Kurbelzapfen == 1) { translate([0, -SteinBreite, -Huelse]) cylinder(h=Huelse, d=FaseD); };
  };   
};

module DrawBremsscheibe() {
  difference() {
    translate([0,0,RadBreite*SteinBreite-Luecken-Huelse-Wandstaerke/2])

    cylinder(d=RadDurchmesser-4*Wandstaerke, h=(GesBreite-RadBreite)*SteinBreite+Wandstaerke/2-Luecken, $fn=fnDetail);
    
    translate([0,0,0])

    cylinder(d=RadDurchmesser-8*Wandstaerke, h=GesBreite*SteinBreite, $fn=fnDetail);
    
      for(i=[0:17])
       rotate([0,0,i*360/18]) 
      translate([RadDurchmesser/2-3*Wandstaerke,0,
      GesBreite*SteinBreite-2*Luecken-Huelse
      
      ])
      sphere(.33, $fn=fnGrob);
  };
};

module Eisenbahnrad() {
  if (Radreifen == 1) {
    difference() {
      DrawRadreifen();
      if (Haftreifen   > 0) DiffHaftreifen();
      if (Txt == 1) revolve_text(textradius, chars);
    };   
    if (Bremsscheibe == 1) {
      if (SpeichenAnzahl == 0) {
        DrawBremsscheibe(); 
      };
    };    
  };  

  if (Radscheibe == 1) {
    DrawHuelse();
    difference() {
      DrawRadscheibe();
      if (Haftreifen > 0) DiffHaftreifen();
      DiffAchshalter();
      if (SpeichenAnzahl > 1) DiffSpeichen();
      if (Kurbelzapfen > 0) DiffKurbelzapfen();
      if (Txt == 1) revolve_text(textradius, chars);      
    };      
    difference() {
      rotate([0,0,Nabenwinkel]) { DrawNabe(); DrawAchshalter(); };
      if (Kurbelzapfen > 0) DiffKurbelzapfen();
    };      
    if (Gegengewicht > 0) {
      difference() {
        DrawGegengewicht();  
        if (Haftreifen > 0) DiffHaftreifen(); 
      };  
    };    
    if (SpeichenAnzahl > 1) {
      difference() {
        DrawSpeichen();
        if (SpeichenAnzahl > 1) DiffAchshalter();
        if (Kurbelzapfen > 0)   DiffKurbelzapfen();
        };    
    };  
    if (Kurbelzapfen > 0) DrawKurbelzapfen();
    if (Kurbelkreuz  > 0) DrawKurbelkreuz();    
  };
};



Eisenbahnrad();